// Chattr - Twitter client on .NET
//
// Copyright (c) 2007 Katsuhiko Ichinose <ichi@users.sourceforge.jp>
//
// Chattr is Free Software released under GNU General Public License.
//
// $Id: IGetTinyUrl.cs 13 2007-10-04 16:00:35Z ichi $

using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace Chattr
{
    class IGetTinyUrl : IGetHttp
    {
        DataSetChattrTableAdapters.TableTinyUrlTableAdapter m_Adapter;
        DataSetChattr.TableTinyUrlDataTable m_Table;
        BackgroundWorker m_Worker;
        Action<string> m_Request;
        Action<bool> m_Exit;

        public IGetTinyUrl(string url, DataSetChattrTableAdapters.TableTinyUrlTableAdapter adapter,
            DataSetChattr.TableTinyUrlDataTable table, BackgroundWorker worker, Action<string> request, Action<bool> exit
            )
            : base(url)
        {
            m_Adapter = adapter;
            m_Table = table;
            m_Worker = worker;
            m_Request = request;
            m_Exit = exit;
        }

        public DataSetChattrTableAdapters.TableTinyUrlTableAdapter Adapter
        {
            get
            {
                return m_Adapter;
            }
        }

        public DataSetChattr.TableTinyUrlDataTable Table
        {
            get
            {
                return m_Table;
            }
        }
        public BackgroundWorker Worker
        {
            get
            {
                return m_Worker;
            }
        }

        public Action<string> Request
        {
            get
            {
                return m_Request;
            }
        }

        public Action<bool> Exit
        {
            get
            {
                return m_Exit;
            }
        }
    }
}
